/*
 * Tiny Embedded JavaScript parser
 *
 * Copyright 2001-2003, Broadcom Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: ej.c,v 1.7 2003/10/29 03:43:55 honor Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <bcmnvram.h>
#include "httpd.h"

static char * get_arg(char *args, char **next);
//static void call(char *func, FILE *stream);
static void call(char *func, webs_t stream);
static char *lastlanguage=NULL;
typedef struct{
char *original;
char *translation;
}LANGUAGE;

//#define DEBUGLOG 1

#ifdef DEBUGLOG
FILE *log;
#define LOG(a) fprintf(log,"%s\n",a);
#else
#define LOG(a)
#endif


static LANGUAGE **language=NULL;
static unsigned int langcount=0;
static void StringStart(FILE *in) 
{
int b=0;
while(b!='"')
    {
    b=getc(in);
    if (b=='\\')
	b=getc(in);
    if (feof(in))return;
    }
}
 
static char *getFileString(FILE *in) 
{ 
char *buf; 
int i,b; 
buf = malloc(1024);
StringStart(in); 
for (i=0;i<1024;i++)   
    {   
    b = getc(in);   
    if (b==EOF)return NULL;   
    if (b=='\\')
    {
    buf[i] = getc(in);
    continue;
    }
    if (b=='"')      
	{      
	buf[i]=0;     
	buf=realloc(buf,strlen(buf)+1);
	return buf;
	}   
    buf[i]=b;   
    }
return buf; 
}

#define LANG_PREFIX "/etc/langpack/"
#define LANG_POSTFIX ".lang"


void initLanguage()
{
int i;
char *fd;
char *original;
char *translate;
char *langstr;
LANGUAGE *desc;
FILE *in;
//if (language!=NULL)return;
langcount=0;
LOG("langstr");
langstr = nvram_safe_get("language");
if (langstr==NULL)return;
if (language!=NULL && lastlanguage!=NULL)
{
if (strcmp(langstr,lastlanguage)!=0)
    {
    lastlanguage = langstr;
    for (i=0;i<langcount;i++)
	{
	free(language[i]->original);
	free(language[i]->translation);
	}
    langcount=0;
    }
}else
if (lastlanguage==NULL)
    lastlanguage = langstr;

LOG("malloc");
fd = (char*)malloc(strlen(LANG_PREFIX)+strlen(langstr)+strlen(LANG_POSTFIX)+1);
sprintf(fd,"%s%s%s",LANG_PREFIX,langstr,LANG_POSTFIX);
LOG("open");
LOG(fd);
in = fopen(fd,"rb");
if (in==NULL)return;
LOG("read desc");
while(1)
{
original = getFileString(in);
if (original==NULL)break;
translate = getFileString(in);
desc = (LANGUAGE*)malloc(sizeof(LANGUAGE));
LOG("entry");
LOG(original);
LOG(translate);   
desc->original = original;
desc->translation = translate;
//realloc space
language = (LANGUAGE**)realloc(language,sizeof(struct LANGUAGE**)*(langcount+2));              
language[langcount++] = desc;
language[langcount]=NULL;
}
fclose(in);
}

char *translatePage(char *input)
{
FILE *in;
char *buffer;
char *dest;
long len;
char *search;
char *replace;
int i,a,z,sl,rl;
LOG("translate");
LOG(input);
in=fopen(input,"rb");
if (in ==NULL)return NULL;
fseek(in,0,SEEK_END);
len = ftell(in);
rewind(in);
buffer=(char*)malloc(len+1);
fread(buffer,1,len,in);
buffer[len]=0;
fclose(in);
for (a=0;a<langcount;a++)
    {
    search = language[a]->original;
    replace = language[a]->translation;
    sl = strlen(search);
    rl = strlen(replace);
    for (i=0;i<len-sl;i++)
	{
	for (z=0;z<sl;z++)
	    {
	    if (search[z]!=buffer[i+z])break;
	    }
	if (z==sl)
	    {
	    //LOG("replace");
	    //LOG(search);
	    //LOG(replace);
	    dest = (char*)malloc(len+rl-sl+1);
	    for (z=0;z<i;z++)dest[z] = buffer[z];
	    for (z=i;z<i+rl;z++) dest[z] = replace[z-i];
	    for (z=i+sl;z<len;z++) dest[z-sl+rl] = buffer[z];
	    dest[z-sl+rl]=0;
	    free(buffer);
	    buffer = dest;
	    len=strlen(buffer);
	    }
	}
    }
LOG("write");
return buffer;
}

/* Look for unquoted character within a string */
static char *
unqstrstr(char *haystack, char *needle)
{
	char *cur;
	int q;

	for (cur = haystack, q = 0;
	     cur < &haystack[strlen(haystack)] && !(!q && !strncmp(needle, cur, strlen(needle)));
	     cur++) {
		if (*cur == '"')
			q ? q-- : q++;
	}
	return (cur < &haystack[strlen(haystack)]) ? cur : NULL;
}

static char *
get_arg(char *args, char **next)
{
	char *arg, *end;

	/* Parse out arg, ... */
	if (!(end = unqstrstr(args, ","))) {
		end = args + strlen(args);
		*next = NULL;
	} else
		*next = end + 1;

	/* Skip whitespace and quotation marks on either end of arg */
	for (arg = args; isspace((int)*arg) || *arg == '"'; arg++);
	for (*end-- = '\0'; isspace((int)*end) || *end == '"'; end--)
		*end = '\0';

	return arg;
}

#define PATTERN_BUFFER 1000
static void
//call(char *func, FILE *stream)
call(char *func, webs_t stream) //jimmy, https, 8/4/2003
{
	char *args, *end, *next;
	int argc;
	char * argv[16];
	struct ej_handler *handler;

	/* Parse out ( args ) */
	if (!(args = strchr(func, '(')))
		return;
	if (!(end = unqstrstr(func, ")")))
		return;
	*args++ = *end = '\0';

	/* Set up argv list */
	for (argc = 0; argc < 16 && args; argc++, args = next) {
		if (!(argv[argc] = get_arg(args, &next)))
			break;
	}

	/* Call handler */
	for (handler = &ej_handlers[0]; handler->pattern; handler++) {
		//if (strncmp(handler->pattern, func, strlen(handler->pattern)) == 0)
		if (strcmp(handler->pattern, func) == 0)
			handler->output(0, stream, argc, argv);
	}
}
//static int webcount=0;
void
//do_ej(char *path, FILE *stream)
do_ej(char *path, webs_t stream)	// jimmy, https, 8/4/2003
{
	FILE *fp;
	int c;
//	char tmpname[256];
	char *pattern, *asp = NULL, *func = NULL, *end = NULL;
	int len = 0;
	int trans=0;
	char *filebuffer;
	long filelen;
	int filecount=0;
	#ifdef DEBUGLOG
	log=fopen("/tmp/log.tmp","wb");
	#endif
	LOG("check language");
	initLanguage();
	if (language==NULL)
	{
	LOG("no lang defined");
	if (!(fp = fopen(path, "r")))
		return;
	fseek(fp,0,SEEK_END);
	filelen = ftell(fp);
	rewind(fp);
	filebuffer = (char*)malloc(filelen+1);
	fread(filebuffer,1,filelen,fp);
	fclose(fp);
	filebuffer[filelen]=0;
	}else
	{
	trans=1;
	LOG("translate");
	//sprintf(tmpname,"/tmp/trans%d.asp",webcount++);
	filebuffer = translatePage(path);
	if (filebuffer==NULL)
	    filebuffer = "file not found!";
	}
	pattern = (char*)malloc(PATTERN_BUFFER);
	while ((c = filebuffer[filecount++]) != 0) {

		/* Add to pattern space */
		pattern[len++] = c;
		pattern[len] = '\0';
		if (len == (PATTERN_BUFFER - 1))
			goto release;


		/* Look for <% ... */
		if (!asp && !strncmp(pattern, "<%", len)) {
			if (len == 2)
				asp = pattern + 2;
			continue;
		}

		/* Look for ... %> */
		if (asp) {
			if (unqstrstr(asp, "%>")) {
				for (func = asp; func < &pattern[len]; func = end) {
					/* Skip initial whitespace */
					for (; isspace((int)*func); func++);
					if (!(end = unqstrstr(func, ";")))
						break;
					*end++ = '\0';

					/* Call function */
					call(func, stream);
				}
				asp = NULL;
				len = 0;
			}
			continue;
		}

	release:
		/* Release pattern space */
		//fputs(pattern, stream);
		wfputs(pattern, stream); //jimmy, https, 8/4/2003
		len = 0;
	}
	free(pattern);
	free(filebuffer);
	#ifdef DEBUGLOG
	fclose(log);
	#endif
}

int
ejArgs(int argc, char **argv, char *fmt, ...)
{
	va_list	ap;
	int arg;
	char *c;

	if (!argv)
		return 0;

	va_start(ap, fmt);
	for (arg = 0, c = fmt; c && *c && arg < argc;) {
		if (*c++ != '%')
			continue;
		switch (*c) {
		case 'd':
			*(va_arg(ap, int *)) = atoi(argv[arg]);
			break;
		case 's':
			*(va_arg(ap, char **)) = argv[arg];
			break;
		}
		arg++;
	}
	va_end(ap);

	return arg;
}
